<template>
  <div>
    <video ref="video" class="my-3 h-[300px]" autoplay></video>
    <p v-if="startTimeout > 0" class="text-4xl text-center text-red-500 my-3 font-medium">
      {{ startTimeout }}
    </p>
  </div>
</template>

<script setup>
import { ref, onMounted, onUnmounted, defineEmits, defineProps } from 'vue'
import { useRecordWizardStore } from '@/stores/recordwizard'

const emit = defineEmits(['ready', 'started', 'stopped', 'canceled'])
const props = defineProps({
  beforeStart: {
    type: Number,
    required: true,
  },
  recordDuration: {
    type: Number,
    required: true,
  },
})

console.log(props.recordDuration)

const store = useRecordWizardStore()
const video = ref(null)
const mediaRecorder = ref(null)
const timeoutID = ref(null)
const videoBlob = ref(null)
// const beforeStart = 5
// const recordDuration = 3
const startTimeout = ref(0)
const canceled = ref(false)
const chunks = ref([])
let stream

const load = async () => {
  try {
    stream = await navigator.mediaDevices.getUserMedia({
      audio: true,
      video: true,
    })
    onReady(stream)
  } catch (err) {
    console.error('[VideoRecorder]', err.name, err.message)
  }
}

const stopWebCam = () => {
  if (stream) {
    stream.getTracks().forEach((track) => track.stop())
    stream = null
  }
}

const onReady = (stream) => {
  let mimeType = 'video/webm'
  if (MediaRecorder.isTypeSupported('video/webm;codecs="vp9,opus"')) {
    mimeType = 'video/webm;codecs="vp9,opus"'
  } else if (MediaRecorder.isTypeSupported('video/webm;codecs="vp8,opus"')) {
    mimeType = 'video/webm;codecs="vp8,opus"'
  }
  mediaRecorder.value = new MediaRecorder(stream, {
    mimeType: mimeType,
  })
  mediaRecorder.value.ondataavailable = onDataAvailable
  mediaRecorder.value.onstop = onStop

  // Set the video source to the stream
  if (video.value) {
    video.value.srcObject = stream
  }

  emit('ready', stream)
}

const intervalId = ref(null)
const start = () => {
  if (mediaRecorder.value === null) {
    return false
  }

  startTimeout.value = props.beforeStart

  canceled.value = false
  if (intervalId.value === null) {
    intervalId.value = setInterval(() => {
      if (startTimeout.value > 0) {
        startTimeout.value -= 1
      } else {
        clearInterval(intervalId.value)
        intervalId.value = null
      }
    }, 1000)
  }
  timeoutID.value = setTimeout(startNow, props.beforeStart * 1000)
}

const startNow = () => {
  if (mediaRecorder.value === null) {
    return false
  }

  chunks.value = []
  mediaRecorder.value.start()

  timeoutID.value = setTimeout(stop, props.recordDuration * 1000)

  emit('started')
}

const stop = () => {
  clearTimeout(timeoutID.value)
  canceled.value = false
  if (mediaRecorder.value.state === 'recording') {
    mediaRecorder.value.stop()
  }
}

const cancel = () => {
  clearTimeout(timeoutID.value)
  canceled.value = true
  if (mediaRecorder.value.state === 'recording') {
    mediaRecorder.value.stop()
  }
  startTimeout.value = 0
  emit('canceled')
}

const onDataAvailable = (event) => {
  console.log('dataavailable')
  videoBlob.value = event.data
  chunks.value.push(event.data)
}

const videoPlayer = ref(null)

const onStop = () => {
  if (canceled.value === true) {
    return
  }

  chunks.value = [] // Empty the chunks directly to save a bit of memory
  console.log(videoBlob.value)
  emit('stopped', videoBlob.value)
}

onMounted(() => {
  load()
})

onUnmounted(() => {
  if (mediaRecorder.value && mediaRecorder.value.state === 'recording') {
    mediaRecorder.value.stop()
  }
  if (intervalId.value !== null) {
    clearInterval(intervalId.value)
  }
  stopWebCam()
})

defineExpose({
  start,
  stop,
  cancel,
})
</script>

<style scoped>
video {
  width: 100%;
  max-width: 600px;
  border: 1px solid #ccc;
  border-radius: 4px;
}
</style>
